#include "cbase.h"
#include "CGmodBasePlugin.h"
#include "interface.h"
#include "SigScan.h"
#include "networkstringtabledefs.h"

GMOD_MODULE(GLoad, GUnload)

CGmodBasePlugin G;
CGmodBasePlugin* gMod = &G;

IVEngineServer *engine = NULL;
IServerPluginHelpers *helpers = NULL;
IEngineTrace *enginetrace = NULL;
INetworkStringTableContainer *networkstringtable = NULL;

int GLoad(lua_State* L)
{
	gMod->m_lua = Lua();

	CSysModule *server = Sys_LoadModule("engine.dll");

	CreateInterfaceFn fn = Sys_GetFactory(server);

	engine = (IVEngineServer*)fn(INTERFACEVERSION_VENGINESERVER, NULL);
	helpers = (IServerPluginHelpers*)fn(INTERFACEVERSION_ISERVERPLUGINHELPERS, NULL);
	enginetrace = (IEngineTrace*)fn(INTERFACEVERSION_ENGINETRACE_SERVER, NULL);

	networkstringtable = (INetworkStringTableContainer *)fn(gMod->m_lua->IsClient() ? INTERFACENAME_NETWORKSTRINGTABLECLIENT : INTERFACENAME_NETWORKSTRINGTABLESERVER,NULL);

	if(	!( engine && helpers && networkstringtable) )
	{
		gMod->m_lua->Msg("GM Lua Dll Failed to Load Interfaces! 0x%x 0x%x 0x%x 0x%x", (size_t)fn, (size_t)engine, (size_t)helpers, (size_t)networkstringtable);
		gMod->m_lua->Error("");
		return 0;
	}

	gMod->Init();

	gMod->m_lua->Msg("Loaded GM Lua DLL.\n");

	return 0;
}

int GUnload(lua_State* L)
{
	gMod->Shutdown();
	return 0;
}