#include "GMLuaModule.h"

#pragma once
#ifndef GMODBASEPLUGIN
#define GMODBASEPLUGIN

class CGmodBasePlugin
{
public:
	CGmodBasePlugin() { };
	~CGmodBasePlugin() { };

	void Init();
	void Shutdown();

	CBaseEntity *GetEntity(int i = -1)
	{
		ILuaObject *ent = m_lua->GetObject(i);
		ILuaObject *entIndexFunc = m_lua->GetMetaTable("Entity", GLua::TYPE_ENTITY)->GetMember("EntIndex");

		m_lua->Push(entIndexFunc);
		m_lua->Push(ent);
		m_lua->Call(1, 1);

		int id = m_lua->GetReturn(0)->GetInt();

		if(id == 0)
			return NULL;

		ent->UnReference();
		entIndexFunc->UnReference();

		return (CBaseEntity *)engine->PEntityOfEntIndex(id)->GetIServerEntity()->GetBaseEntity();
	}

	Vector GetVector(int i = -1)
	{
		ILuaObject *vec = m_lua->GetObject(i);
		ILuaObject *x = vec->GetMember("x");
		ILuaObject *y = vec->GetMember("y");
		ILuaObject *z = vec->GetMember("z");
		Vector a = Vector(x->GetFloat(),y->GetFloat(),z->GetFloat());
		x->UnReference();
		y->UnReference();
		z->UnReference();
		vec->UnReference();

		return a;
	}

	ILuaInterface* m_lua;
};

extern CGmodBasePlugin* gMod;
extern IVEngineServer *engine;
extern IServerPluginHelpers	*helpers;
extern IEngineTrace *enginetrace;
extern INetworkStringTableContainer *networkstringtable;
#endif